function scrollTo($element) {
// --------------------------------
// $element = <DOM object>
// --------------------------------
// Scroll window to element top
// --------------------------------
    var scroll = $element.offset().top;
    var padding_top = 100;
    $("html, body").animate({ scrollTop: scroll - padding_top }, ANIMATION_TIME * 2);
};

function getItemTag($item) {
    tag = $item.attr("class");
    if(typeof(tag) == "string") {
        return tag.split(" ").shift();
    }
    else {
        return "";
    }
}

// ==========================================
//         Update path changed by php
// ==========================================

function updatePath() {
    if(EDIT_PATH.path("filename").path("extension") == "xml") {
        php_path = EDIT_PATH.path("dirname") + "/" + EDIT_PATH.path("filename");
    }
    else {
        php_path = EDIT_PATH;
    };
    path = urlQuery("path");
    if(path == undefined || !path || path == "" || decodeURIComponent(path) != php_path) {
        urlQuery("path=" + encodeURIComponent(php_path));
    };
}

// ==========================================
//         MATCH NAV & EDITOR HEIGHT
// ==========================================

var RESIZE_BUSY = false;
function formResize(delay_time) {
    if(!RESIZE_BUSY) {
        RESIZE_BUSY = true;
        setTimeout(function() {
            $form = $("form#cms");
            $form.css({ "min-height": "100vh" });
            win_hei = $(document).height();
            if(win_hei > $form.height()) {
                $form.css({ "min-height": win_hei });
            };
            setTimeout(function() {
                RESIZE_BUSY = false;
            }, 250)

        }, delay_time + 10);
    };
};

// ==========================================
//                Main Title
// ==========================================

function setMainTitle() {
    // Set main title by navigation label
    if($("nav dd div.current").length && EDIT_PATH.path("extension") != "template") {
        title = $("nav dd div.current").first().find(".item_label p").html();
        $("h2").html( title );
        $("h2 i").remove();
    };
};

// ==========================================
//                  Search
// ==========================================

function getAllDocuments() {
    var documents_list = [];
    var text_files = [ "csv", "txt", "xml" ];

    $("nav dd .nav_item .item_label").each(function() {
        href = $(this).attr("href");
        if(href != undefined && href != "" && text_files.indexOf(href.path("extension")) > -1) {
            documents_list[documents_list.length] = href;
        }
    })
    return documents_list;
};

function getCurrentLanguage() {
    var lang = $("#edit_lang").val();
    $("#lang li").each(function() {
        if($(this).css("display") != "none") {
            lang = $(this).attr("value");
        }
    })
    return lang;
}

function goSearch($trigger) {
    find = $(".search_box input").first().val();
    if(find.length < 3) {
        infoPopup(LOCALIZE["short-text-alert"]);
        $trigger.blur();
    }
    else {
        html = "<form action='search.php' method='post' style='display:none;'>\n" +
                "<input name='find' value='" + find + "'>\n" +
                "<input name='language' value='" + getCurrentLanguage() + "'>\n" +
                "<input name='back_url' value='" + SAVE_PATH + "'>\n" +
                "<textarea name='documents'>" + getAllDocuments().join("\n") + "</textarea>\n" +
            "</form>\n";
        $(".search_box").append(html);

        $(".search_box form").submit();

    };
};

function launchSearchButton() {
    $(".search_box button").click(function() { goSearch($(this)); });
    $('.search_box input').first().on('keypress', function (e) { if(e.which == 13) { goSearch($(this)); }; });
};

// ==========================================
//              Scroll to search
// ==========================================

function launchScrollToSearch() {
    if($("input#search-found").length) {
        setTimeout(function() {
            found = $("input#search-found").val().split(" ");

            $section = $("main article." + found.shift()).eq(found.shift()).find("section." + found.shift());

            if($section.length) {
                // ====== Indicate found item ======
                // Multiple content (files / table cells)
                if(found.length) {
                    type = $section.find("input.type").val();
                    if(type == "media") {
                        $section.find("div.media .thumb").eq(found.shift()).css({ "outline": "5px solid #ffff55" });
                    }
                    else if(type == "table") {
                        $row = $section.find("table." + getCurrentLanguage() + " tr").eq(parseInt(found.shift()) + 1);
                        $cell = $row.find("td").eq(parseInt(found.shift()) + 1);
                        $cell.css({ "background-color": "#ffff88" });
                    }
                }
                // Single content
                else {
                    $section.find("input, textarea").css({ "background-color": "#ffff88" });
                    $section.find("div.image .thumb").css({ "outline": "10px solid #ffff55" });
                }

                // ====== Expand folderd article ======
                $article = $section.closest("article");
                if($article.find(".fold_expand span.fold").css("display") == "none") {
                    $buttons = $article.find("div.fold_expand");
                    $article.find("section").show(100, function() {
                        $buttons.find("span.fold").show();
                        $buttons.find("span.expand").hide();
                    });
                }

                // ====== Scroll to item ======
                setTimeout(function() {
                    search_scroll = $section.offset().top;
                    $("html, body").animate({ scrollTop: search_scroll - 30 }, 500);
                }, 200)

            };
        }, 1000); // wait for article auto-fold complete
    };
};

// ==========================================
//            Footer & copyrights
// ==========================================

function launchFooter() {
    version = $("input#xable_version").val().split(";");
    subject = "[X.able CMS] v" + version[0] + " / " + $("input#site_site_ID").val();

    footer = [
        // Copyrights
        "<b>X.able CMS</b> v" + version[0] + " &copy;" + version[1].substr(0, 4) + " <a href='http://maciejnowak.com' target='_blank'>maciejnowak.com</a>&nbsp;<span class='divide'>|</span>",
        // Standard tools
        "<a href='mailto:maciej@maciejnowak.com?Subject=" + subject + "'><span class='fi-mail help' help='" + LOCALIZE["bug-report"] + "'></span></a>",
        "<a href='backup.php?page=" + encodeURIComponent($("input#saveas").val()) + "' class='unsaved'><span class='fi-save help' help='" + LOCALIZE["site-backup"] + "'></span></a>",
        // Advanced tools
        "<a href='xable_update.php' class='unsaved'><span class='fi-loop creator_module advanced_update help' help='" + LOCALIZE["advanced-tools-label"] + " | " + LOCALIZE["update-label"] + "'></span></a>",
        "<a href='xable_users.php' class='unsaved'><span class='fi-torsos-all creator_module advanced_users help' help='" + LOCALIZE["advanced-tools-label"] + " | " + LOCALIZE["users-groups-label"] + "'></span></a>",
        "<a href='xable_creator.php?open=" + encodeURIComponent($("input#edit_path").val()) + "' class='unsaved'><span class='fi-wrench creator_module advanced_creator help' help='" + LOCALIZE["advanced-tools-label"] + " | " + LOCALIZE["creator-label"] + "'></span></a>",
        "<a href='xable_explorer.php' class='unsaved'><span class='fi-folder creator_module advanced_explorer help' help='" + LOCALIZE["advanced-tools-label"] + " | " + LOCALIZE["file-explorer-label"] + "'></span></a>",
        "<span id='update_output' class='fi-eye creator_module advanced_preview help' help='" + LOCALIZE["xml-preview-label"] + "'></span>"
    ];

    $("form").append("<footer><p>" + footer.join(" ") + "</p></footer>");



    if( $("input#enable_creator").val() != "true" ) {
        // creator_modules
        disableModule(".fi-torsos-all");
        disableModule(".fi-wrench");
        disableModule(".fi-eye");
        disableModule(".fi-loop");
        disableModule(".fi-folder");
        if( $("input#enable_backup").val() != "true" ) { disableModule(".fi-save"); };
        if( $("input#enable_password").val() != "true" ) { disableModule(".fi-torso-business"); };
        //if( $("input#enable_users").val() != "true" ) { disableModule(".fi-torsos-all"); };
    };

    if( $("input#enable_publish").val() != "true" ) {
        $(".publisher_only").remove();
        $("#menu_notifications").remove();
    };

    if( $("input#enable_remove").val() != "false" ) {
        $("nav a").each(function() {
            $(this).children("dd").append("<span class='remove manual fi-x' help='" + LOCALIZE["remove-page"] + "'></span>");
        });
    };
};

function disableModule(icon) {
    // Deactivate
    /*
    $item = $("footer " + icon).closest("a");
    span = $item.html();
    $item.replaceWith(span);
    $("footer " + icon).click(function() {
        $(this).blur();
        alert("Funkcja niedostępna");
    });
    */
    // Hide
    $("footer " + icon).each(function() {
        $a = $(this).parent("a");
        if($a.length) { $a.hide(); }
        else { $(this).hide(); }
    });
};

// ==========================================
//               Initial Popup
// ==========================================

function showInitialPopup() {
    setTimeout(function() {
        if($("input#popup").length) {
            popup = $("input#popup").val().split("|");
            message = popup.shift(); // message text
            popup = popup.pop(); // icon type (if any)
            infoPopup(message, popup);
        };

        //alert($("#upload_info").offset().top);
    }, 500);
};

// ==========================================
//         Launch CMS & Timeout check
// ==========================================

//var SESSION_START = parseInt( new Date().getTime() / 1000 );
var LOGOUT_TIME = 0; // Default: no auto logout
var LOGOUT_WAIT = 30; // seconds for user reaction
var LOGOUT_FLAG = false;

function countDown() {
    setTimeout(function() {
        count = parseInt( $("#countdown").text() );
        if(LOGOUT_FLAG) {
            if(count > 0) {
                $("#countdown").text(--count);
                countDown();
            }
            else {
                $("#loader").fadeIn(500, function() {
                    location.href = "_logout.php?info=" + encodeURI(LOCALIZE["session-expired"]) + "&back_url=" + encodeURI(location.href);
                });
            }
        }
        else {
             autoLogout();
        };
    }, 1000)
};

function autoLogout() {
    setTimeout(function() {
        LOGOUT_FLAG = true;
        info = LOCALIZE["session-timeout-html"];
        info = info.replace("@session_max", Math.round(LOGOUT_TIME / 60));
        info = info.replace("@countdown", LOGOUT_WAIT);
        showPopup("fi-clock", info, LOCALIZE["timeout-reset-button"]);

        $("#popup_box .confirm").click(function() {
            LOGOUT_FLAG = false;
            hidePopup();
        });
        countDown();
    }, (LOGOUT_TIME * 1000) );
};

function launchCms() {
    if($("input#site_logout_time").length && $("input#site_logout_time").val() != "") {
        LOGOUT_TIME = parseInt( $("input#site_logout_time").val() ); // [s]
    }
    else {
        LOGOUT_TIME = 1800; // [s] default 30 minutes
    };

    setTimeout(function() {
        $("#loader").fadeOut(200, function() {
            if(LOGOUT_TIME > 0) { autoLogout(); };
        });
    }, 500);
};